#pragma once

/*
   FIRST LOOK AT INVERTER.H and INVERTER.CPP FOR COMMENTARY AND INSTRUCTIONS!

   SimpleGenerator is an example generator device. It is not commented as heavily as
   the inverter example however -- it is assumed you have already pored over that device,
   and just want to see another example of a different class of device.

*/

// Where the base class generator is derived from
#include "Core/IODevices.h"

// A simple generator device
class SimpleGenerator :
	public Generator
{
public:
	SimpleGenerator(void);
	virtual ~SimpleGenerator(void);

// See Inverter.h for function help
	virtual bool Load(std::istream &in, LoadContext &context);
	virtual bool Save(std::ostream &out, SaveContext &context);

	virtual char *GetDescription() { return "Generates some random noise on the terrain!";};
	virtual char *GetTypeName() { return "Simple Noise Generator"; };

// The hasOrigin() property is false because this simple generator doesn't have an origin.
// See SimpleWorldEffect for an example of a generator that does.
	virtual bool hasOrigin() { return false; };

	virtual bool Activate(BuildContext &context);
};
