#include "StdAfx.h"
#include "simpleoutput.h"
#include "Core/HField.h"
#include "Core/HFieldIO.h"
#include "Core/Context.h"
Device *SimpleOutputMaker() { return new SimpleOutput; };
void SimpleOutputKiller(Device *spr) { delete spr; };


SimpleOutput::SimpleOutput(void)
{
	strcpy_s(filename, "null");
	lifeptrs.maker = SimpleOutputMaker;
	lifeptrs.killer = SimpleOutputKiller;
	strncpy(lifeptrs.nametag, "EXSO", 4);
	SetLinks(1, 0); // inheriting from Output assumes this, but we'll re-emphasize it.
}

SimpleOutput::~SimpleOutput(void)
{
}

// You are REQUIRED to write out and read in your 4-byte Device ID tag, as shown below. It is also recommended that your device
// have an internal version number that you keep track of to allow backwards-compatibility if you ever change your Device save layout...
// Also, make sure you call your super class's Load and Save functions as shown here. Failure to do so will cause major problems.
bool SimpleOutput::Load(std::istream &in, LoadContext &context) {
	char tag[5];
	in.read( tag, 4);
	if (strncmp(tag, lifeptrs.nametag, 4) == 0) {
		int ver = 0;
		in.read((char*) &ver, 1);
		return Output::Load(in, context);
	}
	else
		return false;
};

bool SimpleOutput::Save(std::ostream &out, SaveContext &context) {
	out.write( lifeptrs.nametag, 4);
	int ver = 1;
	out.write((char*) &ver, 1);
	return Output::Save(out, context);
};

// If ANY device has any data that is not stored by the parameter data system it must have a
// doClone function written to properly copy that data when the device is copied.
// In this case, we have the filename variable that needs to be copied.
void SimpleOutput::doClone(Device *other) {
	SimpleOutput *simp = (SimpleOutput*) other;
	strcpy_s(filename, simp->filename);
}

#include <fstream>

bool SimpleOutput::doOutput(OutputData const&outset) {
	std::ofstream ofile("osreport.txt", std::ios::out | std::ios::app);

	// outset.getMode() tells us if this is a normal or tiled build..
	if (outset.getMode() == OUTPUT_NORMAL) { // lets say we do NOT want to participate in tiled builds. You'd usually use a checkbox to ask the user this..
		// We're handed all of our inputs in an OutputData structure. Here's how to retrieve our inputs for export...
		for (int i = 0; i < outset.num(); i++) {
			PacketPointer packet = outset.get(i);	
		}
	}

	ofile << "We've exported a file! for output mode " << outset.getMode() << " with outputset num() reporting : " << outset.num();

	return false;
};



