#pragma once
#include "Core/iodevices.h"

/*
   FIRST LOOK AT INVERTER.H and INVERTER.CPP FOR COMMENTARY AND INSTRUCTIONS!

   SimpleWorldEffect is an example generator device that will scale and pan properly as the
   world render coordinates are changed. Any real-world generator or location-specific effect
   you write will need to do this.

   The effect this generator creates is a basic sine wave pattern emanating from the origin of
   the device.
*/

class SimpleWorldEffect :
	public Generator
{
public:
	SimpleWorldEffect(void);
	~SimpleWorldEffect(void);
// See Inverter.h for function help
	virtual bool Load(std::istream &in, LoadContext &context);
	virtual bool Save(std::ostream &out, SaveContext &context);

	virtual char *GetDescription() { return "Generates a sine wave pattern!";};
	virtual char *GetTypeName() { return "Simple Generator 2"; };

// Generator class sets the hasOrigin() property to true anyways, but for example we're re-emphasizing the fact.
	virtual bool hasOrigin() { return true; };

	virtual bool Activate(BuildContext &bi);
};
