#pragma once
#include "device.h"

/**
	This device is a template to be used to guide you to the minimum implementation necessary for any new devices you create

*/
class DeviceTemplate :
	public Device
{
public:
	DeviceTemplate(void);
	virtual ~DeviceTemplate(void);

// You are required to implement the following virtual functions
	virtual bool Load(std::istream &in, LoadContext &iocontext) override;
	virtual bool Save(std::ostream &out, SaveContext &iocontext) override;
	virtual char *GetDescription() override { return "This is a guide only, and should never be actually created!";};
	virtual char *GetTypeName() override { return "Template"; };
	virtual bool Activate(BuildContext &context);

protected:
// You probably don't need to implement this.
//	virtual void doCreateOutputProxy( BuildContext &proxycontext );
};

